function [OutImg, V] = DLNet_train(InImg,TrnLabels,Tr_idx_R,Tr_idx_C,DLNet)
% ========= CITATION ============
% Yicong Zhou and Yantao Wei, 
% "Learning Hierarchical Spectral-Spatial Features for Hyperspectral Image Classification" IEEE Transactions on Cybernetics, 2015. 

% Yantao Wei [yantaowei@mail.ccnu.edu.cn]
% Please email me if you find bugs, or have suggestions or questions!


if length(DLNet.NumFilters)~= DLNet.NumStages;
    display('Length(DLNet.NumFilters)~=DLNet.NumStages')
    return
end

NumImg = numel(Tr_idx_R);

V = cell(DLNet.NumStages,1); 
ImgIdx = (1:NumImg)';

OutImg=InImg;
NumStage=DLNet.NumStages;

for i=1:NumStage
if(rem(i,2))
display(['Computing LDA filter bank and its outputs at stage ' num2str(i) '...'])
V{i} = LDA_FilterBank(OutImg, TrnLabels,Tr_idx_R,Tr_idx_C); % compute PCA filter banks
OutImg = LDA_output(OutImg, DLNet.NumFilters(i), V{i});
else
display(['Computing AWF filter bank and its outputs at stage ' num2str(i) '...'])

OutImg= F_output(OutImg,DLNet.NumFilters(i));



end
end









